function [ position, newStateMatrix ] = TurtleTrading_p_151021( decisionData, stateMatrix )
%% 꽻׷ϵͳ
%% жϵǰʱ
% һʶflagFirstDay, ǰߵڵһ죺flagFirstDay = 1;
% һBARʶflagFirstBar, ǰߵΪĵһBARflagFirst = 1;
flagFirstDay = 0;
flagFirstBar = 0;

if isempty(stateMatrix)
        flagFirstDay = 1;
        startTime = (decisionData.time-fix(decisionData.time));
        dayCount = -1;
else
        startTime = stateMatrix.startTime; % ʾʱ
        dayCount = stateMatrix.dayCount; % ʾʱ,dayCount=0,dayCount=0ʾһ,dayCount=1ʾڶ,Դ...
end
if abs(decisionData.time-fix(decisionData.time)-startTime)<eps
        flagFirstBar = 1;
        dayCount = dayCount+1;
end
%% ȡ
% (num)
num = length(decisionData.tickerList);
% Լ(cMulti)
cMulti = decisionData.ContractMulti_DAY01.data;
% 쵽ߵ߼(hipCurrent)ͼ(lopCurrent)
if flagFirstBar
        hipCurrent = decisionData.HIP_MIN15.data(:,end);
        lopCurrent = decisionData.LOP_MIN15.data(:,end);
else
        hipCurrent = max(decisionData.HIP_MIN15.data(:,end),stateMatrix.hipCurrent);
        lopCurrent = min(decisionData.LOP_MIN15.data(:,end),stateMatrix.lopCurrent);
end
% µ˹ͱȶ˹ضNֵ,ʵȾֵ(ATRָ)
% ڱ,ͨ19ATRָ(ͨturtleATR)ͽյTRָ(ͨturtleTR)
if flagFirstBar
        hipd01 = decisionData.HIP_DAY01.data(:,end-20:end);
        lopd01 = decisionData.LOP_DAY01.data(:,end-20:end);
        cpd01 = decisionData.CP_DAY01.data(:,end-20:end);
        atr19 = turtleATR(hipd01,lopd01,cpd01,19);
else
        atr19 = stateMatrix.atr19;
end
trToday = turtleTR(hipCurrent, lopCurrent, decisionData.CP_DAY01.data(:,end));
nValue = (19*atr19+trToday)/20;
% гľԲ = NֵԺԼ
mValue = nValue.*cMulti;
%% ˻ģ
% Ͷܶ(InvestTotal)Ͷʱ(InvestRatio)
totalMoney = decisionData.parameters.InvestTotal*decisionData.parameters.InvestRatio;
%% ͷ絥λ
% ÿ5ͷģλĸ
if (mod(dayCount,5)==0) && flagFirstBar
        % ͷģλ, ˻1%/гľԲ
        psnUnit = totalMoney*0.01./mValue;
        psnUnit(psnUnit<1) = 1;
        psnUnit = fix(psnUnit);
else
        psnUnit = stateMatrix.psnUnit;
end
%% ͻƵ(55ͨ),ֵ(55ͨ),˳(20ͨ),ֹ
% prcBreakLong: n*1,ʾͷͻƿֵ
% prcBreakShrt: n*1,ʾղͷͻƿֵ
% prcOpenLong: n*psnLimit,ʾֶڲͬģͷĿֵ
% prcOpenShrt: n*psnLimit,ʾղֶڲͬģͷĿֵ
% prcCloseLong: n*1,ʾڳжֵ˳
% prcCloseShrt: n*1,ʾڳпղֵ˳
% prcStopLong: n*1,ʾڳжֵֹ
% prcStopShrt: n*1,ʾڳпղֵֹ
psnLimit = decisionData.parameters.PsnLimit;
if flagFirstBar
        % 55ͨͻƵ
        % ͻƿֵϼ㲻ͬģͷĿֵ
        % 20ͨƽ˳
        % ֹʼ       
        cp_day01 = decisionData.CP_DAY01.data;
        hip_day01 = decisionData.HIP_DAY01.data;
        lop_day01 = decisionData.LOP_DAY01.data;

        prcBreakLong = max(hip_day01(:,end-54:end),[],2);
        prcBreakShrt = min(lop_day01(:,end-54:end),[],2);

        prcOpenLong = nan(num,psnLimit);
        prcOpenShrt = nan(num,psnLimit);
        
        for i = 1: psnLimit
                prcOpenLong(:,i) = prcBreakLong+(i-1)*0.5.*nValue;
                prcOpenShrt(:,i) = prcBreakShrt-(i-1)*0.5.*nValue;
        end       
        prcCloseLong = min(lop_day01(:,end-19:end),[],2);
        prcCloseShrt = max(hip_day01(:,end-19:end),[],2);       
else
        prcBreakLong = stateMatrix.prcBreakLong;
        prcBreakShrt = stateMatrix.prcBreakShrt;
        prcCloseLong = stateMatrix.prcCloseLong;
        prcCloseShrt = stateMatrix.prcCloseShrt;
        for i = 1: psnLimit
                prcOpenLong(:,i) = prcBreakLong+(i-1)*0.5.*nValue;
                prcOpenShrt(:,i) = prcBreakShrt-(i-1)*0.5.*nValue;
        end
end
if flagFirstDay && flagFirstBar
        prcStopLong = -inf(num,1); 
        prcStopShrt = inf(num,1); 
else
        prcStopLong = stateMatrix.prcStopLong;
        prcStopShrt = stateMatrix.prcStopShrt;
end
%% ֲʼ
% psnOld: num*1,ʾԭֲ,ϸߵĿǰֲ(ͷģλ) 
% psnTrg: num*1,ʾĿֲ(ͷģλ),ʼΪpsnOld
% psnChn: num*1,ʾԭֲֵĿֲֵĸı(ͷģλ)
if flagFirstDay && flagFirstBar
        psnOld = zeros(num,1); 
else
        psnOld = stateMatrix.psnOld;
end
psnTrg = psnOld;
psnChn = zeros(num,1); % ֱֲ仯¼
%% ж
% ݵǰBARļ۸жȷpsnTrgpsnChn
% ǰBARprice
prcBar = decisionData.CP_MIN15.data(:,end);
hipBar = decisionData.HIP_MIN15.data(:,end);
lopBar = decisionData.LOP_MIN15.data(:,end);
for i = 1: num
        if psnOld(i) > 0 
                % жֵ
                % ȿǷƽ
                if lopBar(i) <= prcCloseLong(i) || lopBar(i) <= prcStopLong(i)
                        psnTrg(i) = 0;
                        psnChn(i) = psnTrg(i)-psnOld(i);   
                        prcStopLong(i) = -Inf;
                        prcStopShrt(i) = Inf;
                else
                % ƽ֣ôͿԿǼ
                        target_long = find(hipBar(i)>prcOpenLong(i,:),1,'last');
                        % Ҷֵֿб,ȷݵǰBARܹжͷģλ
                        % ж: ǰBARֵǷڿֵ
                        if ~isempty(target_long)
                        if target_long > psnOld(i)
                                psnTrg(i) = target_long;
                                psnChn(i) = psnTrg(i)-psnOld(i);
                        end
                        end
                        if psnChn(i) > 0 
                        % Ҫֹ֣
                                prcStopLong(i) = prcBar(i)-2*nValue(i);
                                prcStopShrt(i) = Inf;
                        end
                end
        elseif psnOld(i) < 0
                % пղֵ,ͬж
                if hipBar(i) >= prcCloseShrt(i) || hipBar(i) >= prcStopShrt(i)
                        psnTrg(i) = 0;
                        psnChn(i) = psnTrg(i);
                        prcStopLong(i) = -Inf;
                        prcStopShrt(i) = Inf;
                else
                        target_shrt = find(lopBar(i)<prcOpenShrt(i,:),1,'last');
                        if ~isempty(target_shrt)
                        target_shrt = -target_shrt;
                        if target_shrt < psnOld(i)
                            	psnTrg(i) = target_shrt;
                                psnChn(i) = psnTrg(i)-psnOld(i);
                        end
                        end
                        if psnChn(i) < 0
                                prcStopShrt(i) = prcBar(i)+2*nValue(i);
                                prcStopLong(i) = -Inf;
                        end
                end
        end       
        % ĿǰĿֲΪղ֣Ƿ񿪶ֻ߿ղ
        if psnTrg(i) == 0 
                % Ŀֲ
                target_long = find(hipBar(i)>prcOpenLong(i,:),1,'last');
                target_shrt = find(lopBar(i)<prcOpenShrt(i,:),1,'last');
                if ~isempty(target_long)
                        psnTrg(i) = target_long;
                        psnChn(i) = target_long-psnOld(i);
                        prcStopLong(i) = prcBar(i)-2*nValue(i);
                        prcStopShrt(i) = Inf;
                elseif ~isempty(target_shrt)
                        target_shrt = -target_shrt;
                        psnTrg(i) = target_shrt;
                        psnChn(i) = target_shrt-psnOld(i);
                        prcStopShrt(i) = prcBar(i)+2*nValue(i);
                        prcStopLong(i) = -Inf;
                end    
        end
end
%% Ŀͷ
% Ŀͷģͷģλ
position = psnTrg.*psnUnit;
%% Ϣ,¸ߵʹ
newStateMatrix.startTime = startTime;
newStateMatrix.dayCount = dayCount;

newStateMatrix.hipCurrent = hipCurrent;
newStateMatrix.lopCurrent = lopCurrent;
newStateMatrix.atr19 = atr19;

newStateMatrix.prcCloseLong = prcCloseLong;
newStateMatrix.prcCloseShrt = prcCloseShrt;
newStateMatrix.prcBreakLong = prcBreakLong;
newStateMatrix.prcBreakShrt = prcBreakShrt;
newStateMatrix.prcStopLong = prcStopLong;
newStateMatrix.prcStopShrt = prcStopShrt;

newStateMatrix.psnUnit = psnUnit;
newStateMatrix.psnOld = psnTrg;
end
%% ATRTR㷨
%˴ATRQuantraderṩATRAPIҲֱʹøAPI
function atr = turtleATR(hip, lop, cp, period)
% Ƶʵȵperiodڵƽֵ
% ʵ = Max( hip-lop, |hip-lcp|, |lcp-lop|)
tmphip = hip(:,end-period+1:end);
tmplcp = cp(:,end-period:end-1);
tmplop = lop(:,end-period+1:end);
atr = mean(max(max(abs(tmphip-tmplcp),abs(tmplcp-tmplop)),tmphip-tmplop),2);
end
%˴TRQuantraderṩTRAPIҲֱʹøAPI
function tr = turtleTR(hip, lop, lcp)
tr = max(max(abs(hip-lcp),abs(lcp-lop)),hip-lop);
end